%define	name distcc 
%define version 2.18
%define release 1mdk
%define masqdir %{_libdir}/%{name}/bin

Name:           %{name}
Summary:	Program to distribute compilation of C or C++ 
Group:		Development/C
Version:        %{version}
Release:        %{release}
License: 	GPL
URL:		http://distcc.samba.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Packager:	Antoine Ginies <aginies@mandrakesoft.com>
Source:         http://distcc.samba.org/ftp/distcc/%{name}-%{version}.tar.bz2
Source1:	xinetd.d-distcc
BuildRequires:	gtk+2-devel popt-devel
Requires:	%{name}-client %{name}-daemon

%description
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile. 

This package does not contains any files, this is a meta package
used to ease the installation of distcc.

%package	client
Group:		Development/C
Summary:	Program to distribute compilation of C or C++

%description	client
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This is the client, who should be installed on the machine who
act as a master.

%package        masq
Group:          System/Servers
Requires:       %{name}-client
Summary:        Masquerade directory for enabling distcc by default

%description    masq
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contains the masquerade directories that can be used to make
most compiles use distcc by default when configured for parallel builds.

%package	daemon
Group:		System/Servers
Requires: 	gcc-c++ xinetd
Summary:	Program to distribute compilation of C or C++
PreReq:		rpm-helper

%description daemon
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contain the %{name} daemon, installed on the slaves nodes of the
cluster. 

%package	gnome-monitor
Group:		Monitoring
Requires:	%{name}-client
Buildrequires:	libglade2.0-devel libgnome2-devel libgnomeui2-devel
Summary:	Program to monitor distibuted compilation of distcc

%description	gnome-monitor
distcc is a program to distribute compilation of C or C++ code across
several machines on a network. distcc should always generate the same
results as a local compile, is simple to install and use, and is often
two or more times faster than a local compile.

This package contain a graphical version of the distcc monitor.


%prep
%setup -q

%build
%configure --enable-gnome --with-gnome
%make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1/
# cp -r ${RPM_BUILD_DIR}/%{name}-%{version}/man/ ${RPM_BUILD_ROOT}%{_mandir}/man1/
# bzip2 ${RPM_BUILD_ROOT}%{_mandir}/man1/*
%makeinstall
install -m644 %{SOURCE1} -D %{buildroot}/%{_sysconfdir}/xinetd.d/%{name}
rm -rf ${RPM_BUILD_ROOT}%{_docdir}/%{name}

install -d $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
echo localhost > $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/hosts

install -d $RPM_BUILD_ROOT%{_localstatedir}/%{name}d

%{__mkdir} -p $RPM_BUILD_ROOT%{masqdir}
%{__ln_s} %{_bindir}/%{name} $RPM_BUILD_ROOT%{masqdir}/gcc
%{__ln_s} %{_bindir}/%{name} $RPM_BUILD_ROOT%{masqdir}/cc
%{__ln_s} %{_bindir}/%{name} $RPM_BUILD_ROOT%{masqdir}/g++
%{__ln_s} %{_bindir}/%{name} $RPM_BUILD_ROOT%{masqdir}/c++
%{__ln_s} %{_bindir}/%{name} $RPM_BUILD_ROOT%{masqdir}/i586-mandrake-linux-gnu-gcc


install -d %buildroot/%_menudir
cat > %buildroot/%_menudir/%{name}-gnome-monitor <<EOF
?package(%{name}-gnome-monitor): \
command="distccmon-gnome" \
title="Distccmon" \
longtitle="Distcc monitor" \
needs="x11" \
section="Applications/Monitoring" \
icon="monitoring_section.png"
EOF

%pre	daemon
%_pre_useradd %{name}d %{_localstatedir}/%{name}d /bin/bash

%post daemon
# check that /etc/services has been already patched with ditscc port
CHECK_PORT=`grep distcc /etc/services`
if [ -z "$CHECK_PORT" ]; then
	echo " " >> /etc/services
	echo "distcc            3632/tcp # distcc port for daemon" >> /etc/services
	else
	perl -pi -e 's/distcc.*/distcc                3632\/tcp \# distcc port for daemon/' /etc/services
fi

# restarting xinetd service
service xinetd condrestart

%postun daemon
# restarting xinetd service
service xinetd condrestart
%_postun_userdel %{name}d

%post gnome-monitor
%update_menus

%postun gnome-monitor
%clean_menus

%clean
rm -rf $RPM_BUILD_ROOT

# (misc) here to generate a empty rpm, who require the 2 others
%files 

%files client
%defattr(644,root,root,755)
%doc README* INSTALL AUTHORS COPYING doc/*
%{_mandir}/man1/%{name}.1*
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/hosts
%defattr(755,root,root,755)
%{_bindir}/%{name}
%{_bindir}/%{name}mon-text
%{_mandir}/man1/%{name}mon-text.*

%files masq
%defattr(644,root,root,755)
%attr(0755,root,root) %{masqdir}

%files gnome-monitor
%defattr(-,root,root)
%_menudir/*
%{_bindir}/%{name}mon-gnome
%_datadir/%name/*.png
%_datadir/%name/*.desktop
#%_datadir/*.glade*


%files daemon
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}
%{_bindir}/%{name}d*
%{_mandir}/man1/%{name}d.1*
%defattr(-,distccd,distccd)
%{_localstatedir}/%{name}d

%changelog
* Tue Oct 12 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.18-1mdk
- 2.18

* Fri Sep 10 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.17-2mdk
- from Richard Houser <rick@divinesymphony.net> : 
	- New masq directory in %{masqdir}, just add to the start of your path

* Tue Aug 03 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.17-1mdk
- 2.17

* Mon Jul 19 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.16-1mdk
- 2.16

* Mon May 17 2004 Antoine Ginies <aginies@n2.mandrakesoft.com> 2.14-2mdk
- remove verbose log in xinetd

* Thu May  6 2004  <lenny@mandrakesoft.com> 2.14-1mdk
- New release 2.14

* Tue Apr 06 2004  Erwan Velu <erwan@mandrakesoft.com> 2.13-1mdk
- 2.13

* Fri Jan 09 2004 Lenny Cartier <lenny@mandrakesoft.com> 2.12.1-1mdk
- 2.12.1
- add distccmon-text manpage

* Sun Dec 21 2003 Per yvind Karlsen <peroyvind@linux-mandrake.com> 2.12-2mdk
- run under own user
- spec cosmetics
- fix buildrequires (lib64..)
- define TMPDIR=/tmp (fixes #6225)

* Fri Dec 19 2003 Michael Scherer <misc@mandrake.org> 2.12-1mdk
- 2.12
 
* Thu Oct 23 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.11.2-1mdk
- 2.11.2

* Mon Sep 29 2003 Antoine Ginies <aginies@mandrakesoft.com> 2.11-2mdk
- fix Buildrequires

* Tue Sep 23 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.11-1mdk
- 2.11
- add some files for gnome-mono (but place is not satisfying)

* Mon Sep 01 2003 Michael Scherer <scherer.michael@free.fr> 2.10.1-3mdk 
- fix last changelog
- BuildRequires libgtk+2.0_0-devel
- added a package distcc to ease the upgrade
- split gtk-monitor from client
- use service xinetd condrestart

* Thu Aug 14 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.10.1-2mdk
- following the Andre Duclos idea, split the package
- enable gnome monitor
- add menu entry

* Wed Aug 13 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.10.1-1mdk
- 2.10

* Wed Jul 23 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.9-1mdk
- 2.9 (\o/ packaged before Per yvind)

* Wed Jul 09 2003 Per yvind Karlsen <peroyvind@sintrax.net> 2.8-1mdk
- 2.8
- drop Prefix tag

* Fri Jun 27 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.7.1-1mdk
- 2.7.1

* Fri Jun 06 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.5.1-1mdk
- 2.5.1

* Wed Jun 04 2003 Per yvind Karlsen <peroyvind@sintrax.net> 2.5-3mdk
- add confdir and configfile for hosts

* Tue Jun 03 2003 Per yvind Karlsen <peroyvind@sintrax.net> 2.5-2mdk
- spec file fixes and cleanups

* Wed May 28 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.5-1mdk
- 2.5

* Mon May 05 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.2-1mdk
- 2.2

* Mon Mar 31 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.0.1-1mdk
- 2.0.1
- remove infopages post & postun
- minor clean spec

* Mon Mar 24 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.2.3-1mdk
- 1.2.3

* Thu Feb 27 2003 Lenny Cartier <lenny@mandrakesoft.com> 1.2.2-1mdk
- 1.2.2

* Sat Feb 22 2003 Antoine Ginies <aginies@mandrakesoft.com> 1.2-1mdk
- new release

* Tue Jan 28 2003 Antoine Ginies <aginies@mandrakesoft.com> 1.1-1mdk
- new release 1.1

* Thu Jan 16 2003 Antoine Ginies <aginies@mandrakesoft.com> 1.0-1mdk
- release 1.0

* Thu Dec 12 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.15-2mdk
- correct to adjust to new default port 3632

* Thu Dec 12 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.15-1mdk
- new release 0.15

* Tue Dec 03 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.14-1mdk
- new release 0.14

* Tue Nov 12 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.13-1mdk
- release 0.13

* Tue Oct 08 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.12-3mdk
- correct /etc/services

* Mon Oct 07 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.12-2mdk
- include distccd in xinetd service
- add disttc port in /etc/services

* Mon Oct 07 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.12-1mdk
- release 0.12

* Sun Sep 29 2002 Antoine Ginies <aginies@mandrakesoft.com> 0.11.0-1mdk
- sorry for overwritting first spec. 
- release 0.11

* Mon Sep 16 2002 Lenny Cartier <lenny@mandrakesoft.com> 0.10.1-1mdk
- from Austin Acton <aacton@yorku.ca> :
- update to 0.10.1

* Thu Aug 22 2002 Lenny Cartier <lenny@mandrakesoft.com> 0.8-1mdk
- from Austin Acton <aacton@yorku.ca> :
- update to 0.8

* Tue Aug 06 2002 Xavier Granier <xavier.granier@laposte.net> 0.6-1mdk
- First packaging
